VTK: vtkClosedSurfacePointPlacer Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkClosedSurfacePointPlacer Class Reference

PointPlacer to constrain validity within a set of convex planes. More...

`#include <vtkClosedSurfacePointPlacer.h>`

Inheritance diagram for vtkClosedSurfacePointPlacer:
[legend]
Collaboration diagram for vtkClosedSurfacePointPlacer:
[legend]

## Public Types
typedef vtkPointPlacer | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkPointPlacer
typedef vtkObject | Superclass
| Standard methods for instances of this class. More...

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkClosedSurfacePointPlacer * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | AddBoundingPlane (vtkPlane *plane)
| A collection of plane equations used to bound the position of the point. More...
void | RemoveBoundingPlane (vtkPlane *plane)
void | RemoveAllBoundingPlanes ()
virtual void | SetBoundingPlanes (vtkPlaneCollection *)
virtual vtkPlaneCollection * | GetBoundingPlanes ()
void | SetBoundingPlanes (vtkPlanes *planes)
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double worldPos[3], double worldOrient[9]) override
| Given a renderer and a display position, compute the world position and world orientation for this point. More...
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[2], double worldPos[3], double worldOrient[9]) override
| Given a renderer, a display position and a reference position, "worldPos" is calculated as : Consider the line "L" that passes through the supplied "displayPos" and is parallel to the direction of projection of the camera. More...
int | ValidateWorldPosition (double worldPos[3]) override
| Give a world position check if it is valid - does it lie on the plane and within the bounds? Returns 1 if it is valid, 0 otherwise. More...
int | ValidateWorldPosition (double worldPos[3], double worldOrient[9]) override
| Given a world position and a world orientation, validate it according to the constraints of the placer. More...
virtual void | SetMinimumDistance (double)
virtual double | GetMinimumDistance ()
Public Member Functions inherited from vtkPointPlacer
vtkPointPlacer * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[3], double worldPos[3], double worldOrient[9])
| Given a renderer, a display position, and a reference world position, compute the new world position and orientation of this point. More...
virtual int | ValidateDisplayPosition (vtkRenderer *, double displayPos[2])
| Given a display position, check the validity of this position. More...
virtual int | UpdateWorldPosition (vtkRenderer *ren, double worldPos[3], double worldOrient[9])
| Given a current renderer, world position and orientation, update them according to the constraints of the placer. More...
virtual int | UpdateNodeWorldPosition (double worldPos[3], vtkIdType nodePointId)
| Give the placer a chance to update the node information, if any. More...
virtual int | UpdateInternalState ()
| Called by the representation to give the placer a chance to update itself. More...
virtual void | SetPixelTolerance (int)
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual int | GetPixelTolerance ()
virtual void | SetWorldTolerance (double)
| Set/get the tolerance used when performing computations in world coordinates. More...
virtual double | GetWorldTolerance ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkClosedSurfacePointPlacer * | New ()
| Instantiate this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkClosedSurfacePointPlacer * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkPointPlacer
static vtkPointPlacer * | New ()
| Instantiate this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPointPlacer * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkClosedSurfacePointPlacer ()
| ~vtkClosedSurfacePointPlacer () override
void | BuildPlanes ()
Protected Member Functions inherited from vtkPointPlacer
| vtkPointPlacer ()
| ~vtkPointPlacer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static double | GetDistanceFromObject (double pos[3], vtkPlaneCollection *pc, double closestPt[3])

## Protected Attributes
vtkPlaneCollection * | BoundingPlanes
double | MinimumDistance
vtkPlaneCollection * | InnerBoundingPlanes
Protected Attributes inherited from vtkPointPlacer
int | PixelTolerance
double | WorldTolerance
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

PointPlacer to constrain validity within a set of convex planes.

This placer takes a set of boudning planes and constraints the validity within the supplied convex planes. It is used by the ParallelopPipedRepresentation to place constraints on the motion the handles within the parallelopiped.

See also
  vtkParallelopipedRepresentation

Definition at line 39 of file vtkClosedSurfacePointPlacer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointPlacer vtkClosedSurfacePointPlacer::Superclass

Standard methods for instances of this class.

Definition at line 51 of file vtkClosedSurfacePointPlacer.h.

## Constructor & Destructor Documentation

## ◆ vtkClosedSurfacePointPlacer()

vtkClosedSurfacePointPlacer::vtkClosedSurfacePointPlacer | ( |  | ) |
| protected

## ◆ ~vtkClosedSurfacePointPlacer()

vtkClosedSurfacePointPlacer::~vtkClosedSurfacePointPlacer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkClosedSurfacePointPlacer* vtkClosedSurfacePointPlacer::New | ( |  | ) |
| static

Instantiate this class.

## ◆ IsTypeOf()

static vtkTypeBool vtkClosedSurfacePointPlacer::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkClosedSurfacePointPlacer::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkPointPlacer.

## ◆ SafeDownCast()

static vtkClosedSurfacePointPlacer* vtkClosedSurfacePointPlacer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkClosedSurfacePointPlacer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkPointPlacer.

## ◆ NewInstance()

vtkClosedSurfacePointPlacer* vtkClosedSurfacePointPlacer::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkClosedSurfacePointPlacer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ AddBoundingPlane()

void vtkClosedSurfacePointPlacer::AddBoundingPlane | ( | vtkPlane * | plane | ) |

A collection of plane equations used to bound the position of the point.

This is in addition to confining the point to a plane - these constraints are meant to, for example, keep a point within the extent of an image. Using a set of plane equations allows for more complex bounds (such as bounding a point to an oblique reliced image that has hexagonal shape) than a simple extent.

## ◆ RemoveBoundingPlane()

void vtkClosedSurfacePointPlacer::RemoveBoundingPlane | ( | vtkPlane * | plane | ) |

## ◆ RemoveAllBoundingPlanes()

void vtkClosedSurfacePointPlacer::RemoveAllBoundingPlanes | ( |  | ) |

## ◆ SetBoundingPlanes() [1/2]

virtual void vtkClosedSurfacePointPlacer::SetBoundingPlanes | ( | vtkPlaneCollection * |  | ) |
| virtual

## ◆ GetBoundingPlanes()

virtual vtkPlaneCollection* vtkClosedSurfacePointPlacer::GetBoundingPlanes | ( |  | ) |
| virtual

## ◆ SetBoundingPlanes() [2/2]

void vtkClosedSurfacePointPlacer::SetBoundingPlanes | ( | vtkPlanes * | planes | ) |

## ◆ ComputeWorldPosition() [1/2]

int vtkClosedSurfacePointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a renderer and a display position, compute the world position and world orientation for this point.

A plane is defined by a combination of the ProjectionNormal, ProjectionOrigin, and ObliquePlane ivars. The display position is projected onto this plane to determine a world position, and the orientation is set to the normal of the plane. If the point cannot project onto the plane or if it falls outside the bounds imposed by the BoundingPlanes, then 0 is returned, otherwise 1 is returned to indicate a valid return position and orientation.

Reimplemented from vtkPointPlacer.

## ◆ ComputeWorldPosition() [2/2]

int vtkClosedSurfacePointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | refWorldPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| override

Given a renderer, a display position and a reference position, "worldPos" is calculated as : Consider the line "L" that passes through the supplied "displayPos" and is parallel to the direction of projection of the camera.

Clip this line segment with the parallelopiped, let's call it "L_segment". The computed world position, "worldPos" will be the point on "L_segment" that is closest to refWorldPos. NOTE: Note that a set of bounding planes must be supplied. The Oblique plane, if supplied is ignored.

## ◆ ValidateWorldPosition() [1/2]

int vtkClosedSurfacePointPlacer::ValidateWorldPosition | ( | double | worldPos[3] | ) |
| overridevirtual

Give a world position check if it is valid - does it lie on the plane and within the bounds? Returns 1 if it is valid, 0 otherwise.

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [2/2]

int vtkClosedSurfacePointPlacer::ValidateWorldPosition | ( | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given a world position and a world orientation, validate it according to the constraints of the placer.

Reimplemented from vtkPointPlacer.

## ◆ SetMinimumDistance()

virtual void vtkClosedSurfacePointPlacer::SetMinimumDistance | ( | double |  | ) |
| virtual

## ◆ GetMinimumDistance()

virtual double vtkClosedSurfacePointPlacer::GetMinimumDistance | ( |  | ) |
| virtual

## ◆ GetDistanceFromObject()

static double vtkClosedSurfacePointPlacer::GetDistanceFromObject | ( | double | pos[3],
|  | vtkPlaneCollection * | pc,
|  | double | closestPt[3]
| ) |  |
| staticprotected

## ◆ BuildPlanes()

void vtkClosedSurfacePointPlacer::BuildPlanes | ( |  | ) |
| protected

## Member Data Documentation

## ◆ BoundingPlanes

vtkPlaneCollection* vtkClosedSurfacePointPlacer::BoundingPlanes
| protected

Definition at line 127 of file vtkClosedSurfacePointPlacer.h.

## ◆ MinimumDistance

double vtkClosedSurfacePointPlacer::MinimumDistance
| protected

Definition at line 136 of file vtkClosedSurfacePointPlacer.h.

## ◆ InnerBoundingPlanes

vtkPlaneCollection* vtkClosedSurfacePointPlacer::InnerBoundingPlanes
| protected

Definition at line 137 of file vtkClosedSurfacePointPlacer.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkClosedSurfacePointPlacer.h